## START: Set by rpmautospec
## (rpmautospec version 0.7.3)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 1;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

Name:		zmusic
Version:	1.1.14
Release:	%autorelease
Summary:	GZDoom's music system as a standalone library

# DUMB license is equal to Zlib in last revision (0.9.3)
License:	GPL-3.0-or-later and LGPL-3.0-or-later and MIT and BSD-3-Clause and Zlib
URL:		https://github.com/ZDoom/ZMusic
Source0:	%{url}/archive/refs/tags/%{version}.tar.gz

# TODO: add upstream issue tracker links
Patch:          zmusic-0001-unbundle-fluidsynth.patch
Patch:          zmusic-0002-unbundle-libxmp.patch

BuildRequires:	g++
BuildRequires:	cmake
BuildRequires:	libsndfile-devel
BuildRequires:	mpg123-devel
BuildRequires:	alsa-lib-devel
BuildRequires:	fluidsynth-devel
BuildRequires:	libxmp-devel

# GPL-3.0-or-later
Provides:       bundled(adlmidi)        = 1.5.1
# Zlib (DUMB 0.9.3)
Provides:       bundled(dumb)           = 1.0.0
# LGPL-2.1-or-later
Provides:       bundled(fluidsynth)     = 2.2.8
# LGPL-2.1-or-later
Provides:       bundled(game-music-emu) = 0.6.2
# LGPL-2.1-or-later
Provides:       bundled(libxmp)         = 4.6.0
# MIT
Provides:       bundled(miniz)          = 3.0.0
# LGPL-2.1-or-later
Provides:       bundled(oplsynth)
# GPL-3.0-or-later
Provides:       bundled(opnmidi)        = 1.5.1
# LGPL-2.1-or-later
Provides:       bundled(timidity)
# GPL-2.0-or-later
Provides:       bundled(timidity++)
# LGPL-3.0-or-later
Provides:       bundled(wildmidi)

%package	lite
Summary:	GZDoom's music system as a standalone library, Lite version
License:	LGPL-2.1-or-later and MIT and Zlib

%package	devel
Summary:	Libraries for %{name}
Requires:	%{name}%{?_isa} = %{version}-%{release}
Requires:	%{name}-headers = %{version}-%{release}

%package	lite-devel
Summary:	Libraries for %{name}-lite
Requires:	%{name}-lite%{?_isa} = %{version}-%{release}	
Requires:	%{name}-headers = %{version}-%{release}
License:	LGPL-2.1-or-later and MIT and Zlib

%package	headers
Summary:	Header files for %{name}
Requires:	(%{name}-devel%{?_isa} = %{version}-%{release} or %{name}-lite-devel%{?_isa} = %{version}-%{release})
License:	GPL-3.0-or-later and BSD-3-Clause

%description
GZDoom's music system as a standalone library

%description    lite
GZDoom's music system as a standalone library, Lite version

%description    devel
The %{name}-devel package contains libraries needed for developing
applications that use %{name}

%description    lite-devel
The %{name}-lite-devel package contains libraries needed for developing
applications that use %{name}-lite

%description    headers
The %{name}-headers package contains header files needed for developing
applications that use %{name} or %{name-lite}

%prep
%autosetup -n ZMusic-%{version} -p1

rm -rf thirdparty/fluidsynth
rm -rf thirdparty/libxmp
rm thirdparty/mpg123.h
rm thirdparty/sndfile.h

# DUMB license in licenses folder is outdated
# https://github.com/ZDoom/ZMusic/issues/64
cp thirdparty/dumb/licence.txt licenses/dumb.txt

%build
%cmake	-DDYN_SNDFILE=OFF \
	-DDYN_MPG123=OFF
%cmake_build

%install
%cmake_install

%check
%ctest

%files
%license licenses/* 
%{_libdir}/libzmusic.so.1
%{_libdir}/libzmusic.so.1.1.14

%files	lite
%license licenses/* 
%{_libdir}/libzmusiclite.so.1{,.*}

%files	devel
%{_libdir}/libzmusic.so

%files	lite-devel
%{_libdir}/libzmusiclite.so

%files	headers
%{_includedir}/zmusic.h
%{_libdir}/cmake/ZMusic/ZMusicConfig.cmake
%{_libdir}/cmake/ZMusic/ZMusicConfigVersion.cmake
%{_libdir}/cmake/ZMusic/ZMusicFullTargets-debug.cmake
%{_libdir}/cmake/ZMusic/ZMusicFullTargets.cmake
%{_libdir}/cmake/ZMusic/ZMusicLiteTargets-debug.cmake
%{_libdir}/cmake/ZMusic/ZMusicLiteTargets.cmake

%changelog
## START: Generated by rpmautospec
* Mon Dec 23 2024 John Doe <packager@example.com> - 1.1.14-1
- Uncommitted changes
## END: Generated by rpmautospec
